#include <font610.h>
#include <miac.h>

miac miac;

char theDate[8];
char theTime[8];
uint8_t selection = 0;
uint8_t key;

void moveCursor(void)
{
  switch (selection)
  {
    case 0: miac.cursor(0,3); break;
    case 1: miac.cursor(1,3); break;
    case 2: miac.cursor(3,3); break;
    case 3: miac.cursor(4,3); break;
    case 4: miac.cursor(6,3); break;
    case 5: miac.cursor(7,3); break;
    case 6: miac.cursor(10,3); break;
    case 7: miac.cursor(11,3); break;
    case 8: miac.cursor(13,3); break;
    case 9: miac.cursor(14,3); break;
    case 10: miac.cursor(16,3); break;
    case 11: miac.cursor(17,3); break;
  }
}

void drawCursor(void)
{
  moveCursor();
  miac.print('^');
}

void clearCursor(void)
{
  moveCursor();
  miac.print(' ');
}

void left()
{
  if (selection > 0)
  {
    clearCursor();
    --selection;
    drawCursor();
  }
}

void right()
{
  if (selection < 11)
  {
    clearCursor();
    ++selection;
    drawCursor();
  }
}

void incTime(char *data, uint8_t max)
{
  if (*data < (max + '0'))
  {
    *data += 1;
    miac.timeWrite(theTime);
  }
}

void decTime(char *data)
{
  if (*data > '0')
  {
    *data -= 1;
    miac.timeWrite(theTime);
  }
}

void incDate(char *data, uint8_t max)
{
  if (*data < (max + '0'))
  {
    *data += 1;
    miac.dateWrite(theDate);
  }
}

void decDate(char *data)
{
  if (*data > '0')
  {
    *data -= 1;
    miac.dateWrite(theDate);
  }
}

void up()
{
  switch (selection)
  {
    case 0: incDate(&theDate[0],3); break;
    case 1: incDate(&theDate[1],9); break;
    case 2: incDate(&theDate[2],1); break;
    case 3: incDate(&theDate[3],9); break;
    case 4: incDate(&theDate[4],9); break;
    case 5: incDate(&theDate[5],9); break;
    case 6: incTime(&theTime[0],2); break;
    case 7: incTime(&theTime[1],9); break;
    case 8: incTime(&theTime[2],5); break;
    case 9: incTime(&theTime[3],9); break;
    case 10: incTime(&theTime[4],5); break;
    case 11: incTime(&theTime[5],9); break;
  }
}

void down()
{
  switch (selection)
  {
    case 0: decDate(&theDate[0]); break;
    case 1: decDate(&theDate[1]); break;
    case 2: decDate(&theDate[2]); break;
    case 3: decDate(&theDate[3]); break;
    case 4: decDate(&theDate[4]); break;
    case 5: decDate(&theDate[5]); break;
    case 6: decTime(&theTime[0]); break;
    case 7: decTime(&theTime[1]); break;
    case 8: decTime(&theTime[2]); break;
    case 9: decTime(&theTime[3]); break;
    case 10: decTime(&theTime[4]); break;
    case 11: decTime(&theTime[5]); break;
  }
}

void setup()
{
  miac.cursor(5,1);
  miac.print("MIAC Clock");
  // setup the initial pointer
  drawCursor();
}

void loop()
{
  delay(50);             // wait a while
  miac.dateRead(theDate);
  miac.cursor(0,2);
  // print the date DD/MM/YY
  miac.print(theDate[0]);
  miac.print(theDate[1]);
  miac.print('/');
  miac.print(theDate[2]);
  miac.print(theDate[3]);
  miac.print('/');
  miac.print(theDate[4]);
  miac.print(theDate[5]);
  miac.timeRead(theTime);
  miac.cursor(10,2);
  // print the time HH:MM:SS
  miac.print(theTime[0]);
  miac.print(theTime[1]);
  miac.print(':');
  miac.print(theTime[2]);
  miac.print(theTime[3]);
  miac.print(':');
  miac.print(theTime[4]);
  miac.print(theTime[5]);
  key = miac.keypadRead();
  switch (key)
  {
    case 1: left(); break;
    case 7: right(); break;
    case 3: down(); break;
    case 5: up(); break;
  }
}

