#include <font610.h>
#include <miac.h>

// This demo sketch ...
// Motor 1 connected between Terminals A and B is controlled by PWM
// Motor 2 connected between Terminals C and D is not controlled by PWM

// Initialise the MIAC
miac miac;

uint8_t dutyCycle = 1;
uint8_t countUp = 1;
uint8_t motorDirection = 1;

void setup()
{
  // Print intial text to the screen
  miac.print("MIAC PWM Example");

  // Initialise the PWM and outputs for Motor "1" on outputs "A" and "B"
  miac.outputBridgePWM(1, dutyCycle, 32);  // Motor 1, initial duty and clock prescaler
  miac.outputHigh(1);           // Output A
  miac.outputLow(2);            // Output B
  // Initialise the static outputs for Motor "2" on outputs "C" and "D"
  miac.outputHigh(3);           // Output C
  miac.outputLow(4);            // Output D
}

void loop()
{
  delay(10);
  // Increment or decrement the duty cycle value
  if (countUp)
    ++dutyCycle;
  else
    --dutyCycle;
  
  if (dutyCycle > 253)
  {
    countUp = 0; 
    //dutyCycle = 252;
  } 
  else if (dutyCycle < 2)
  {
    countUp = 1; 
    //dutyCycle = 2;
    // Change the direction of Motors 1 and 2
    if (motorDirection)
    {
      motorDirection = 0;
      miac.outputLow(1);
      miac.outputHigh(2);
      miac.outputLow(3);
      miac.outputHigh(4);
    }
    else
    {
      motorDirection = 1;
      miac.outputHigh(1);
      miac.outputLow(2);
      miac.outputHigh(3);
      miac.outputLow(4);
    }
    
  };
  // Update the duty cycle for Motor 1 (on A and B)
  miac.outputBridgePWM(1, dutyCycle);
  
}


